<template>
<nav class="menu" ref="menuContiner" id="menuContinerId">
  <input type="checkbox" href="#" class="menu-open" name="menu-open" id="menu-open"
    ref="picked1" v-on:click="toggleMenuPosition">
  <label class="menu-open-button" for="menu-open">
    <span class="lines line-1"></span>
    <span class="lines line-2"></span>
    <span class="lines line-3"></span>
  </label>

  <a href="#" class="menu-item item-1" v-on:click="menuRadial('item-1')">
    <i><font-awesome-icon :icon="['fas', 'redo']" size="1x"/></i>
  </a>
  <a href="#" class="menu-item item-2" v-on:click="menuRadial('item-2')">
    <i><font-awesome-icon :icon="['fas', 'redo']" size="1x"/></i>
  </a>
  <a href="#" class="menu-item item-3" v-on:click="menuRadial('item-3')"></a>
  <a href="#" class="menu-item item-4" v-on:click="menuRadial('item-4')"></a>
  <a href="#" class="menu-item item-5" v-on:click="menuRadial('item-5')"></a>
  <a href="#" class="menu-item item-6" v-on:click="menuRadial('item-6')"></a>
</nav>
</template>

<script lang="ts">
import { defineComponent, ref, computed, onMounted } from 'vue'
import { FontAwesomeIcon } from '@fortawesome/vue-fontawesome'
import { library } from '@fortawesome/fontawesome-svg-core'
import { faLink, faSave, faUndo, faRedo } from '@fortawesome/free-solid-svg-icons'

library.add(faLink, faSave, faUndo, faRedo)
export default defineComponent({
  components: {
    'font-awesome-icon': FontAwesomeIcon
  },
  props: {
    myButtonSize: {
      type: Number,
      default: 60
    }
  },
  setup (props) {
    // References
    const picked1 = ref()
    const menuContiner = ref()
    // vars
    const buttonSize:string = props.myButtonSize + 'px'
    const buttonMarginLeft: string = (props.myButtonSize / (-2)).toString() + 'px'
    const buttonMarginRight: string = (props.myButtonSize / 2).toString() + 'px'
    const buttonLineHeight: string = (props.myButtonSize).toString() + 'px'
    let menuPosition = 'relative'

    onMounted(() => {
      // console.log(picked1.value.value)
      console.log(menuContiner.value.style)
    })
    const optionSelected = computed(() => {
      console.log('here')
      console.log(picked1.value.value)
      return true
    })

    const toggleMenuPosition = () => {
      console.log('here-here')
      menuPosition = 'absoluted'
    }

    const menuRadial = (itemSelected) => {
      console.log(itemSelected)
    }

    // console.log(buttonMargin)
    return {
      // refs
      picked1,
      menuContiner,
      // vars
      buttonSize,
      buttonMarginLeft,
      buttonMarginRight,
      buttonLineHeight,
      menuPosition,
      // computed
      optionSelected,
      // methods
      menuRadial,
      toggleMenuPosition
    }
  }
})
</script>

<style scoped>

/* Style the menu toggle button.*/
.menu-open-button {
  background: #EEEEEE;
  border-radius: 100%;
  width: v-bind(buttonSize);
  height:v-bind(buttonSize);
  /*margin-left:  v-bind(buttonMarginLeft);*/
  /*margin-top:  v-bind(buttonMarginRight);*/
  position: absolute;
  color: #FFFFFF;
  text-align: center;
  line-height: 60px;
  -webkit-transform: translate3d(0, 0, 0);
  transform: translate3d(0, 0, 0);
  -webkit-transition: -webkit-transform ease-out 200ms;
  transition: -webkit-transform ease-out 200ms;
  transition: transform ease-out 200ms;
  transition: transform ease-out 200ms, -webkit-transform ease-out 200ms;
}

.menu-open {
  display: none;
}

.lines {
  width: 25px;
  height: 3px;
  background: #596778;
  display: block;
  position: absolute;
  top: 50%;
  left: 50%;
  margin-left: -12.5px;
  margin-top: -1.5px;
  -webkit-transition: -webkit-transform 200ms;
  transition: -webkit-transform 200ms;
  transition: transform 200ms;
  transition: transform 200ms, -webkit-transform 200ms;
}

.line-1 {
  -webkit-transform: translate3d(0, -8px, 0);
  transform: translate3d(0, -8px, 0);
}

.line-2 {
  -webkit-transform: translate3d(0, 0, 0);
  transform: translate3d(0, 0, 0);
}

.line-3 {
  -webkit-transform: translate3d(0, 8px, 0);
  transform: translate3d(0, 8px, 0);
}

.menu-open:checked + .menu-open-button {
  position: absolute;
}

.menu-open:checked + .menu-open-button .line-1 {
  -webkit-transform: translate3d(0, 0, 0) rotate(45deg);
  transform: translate3d(0, 0, 0) rotate(45deg);
}

.menu-open:checked + .menu-open-button .line-2 {
  -webkit-transform: translate3d(0, 0, 0) scale(0.1, 1);
  transform: translate3d(0, 0, 0) scale(0.1, 1);
}

.menu-open:checked + .menu-open-button .line-3 {
  -webkit-transform: translate3d(0, 0, 0) rotate(-45deg);
  transform: translate3d(0, 0, 0) rotate(-45deg);
}

.menu-open-button {
  z-index: 2;
  -webkit-transition-timing-function: cubic-bezier(0.175, 0.885, 0.32, 1.275);
  transition-timing-function: cubic-bezier(0.175, 0.885, 0.32, 1.275);
  -webkit-transition-duration: 400ms;
  transition-duration: 400ms;
  -webkit-transform: scale(1.1, 1.1) translate3d(0, 0, 0);
  transform: scale(1.1, 1.1) translate3d(0, 0, 0);
  cursor: pointer;
  box-shadow: 3px 3px 0 0 rgba(0, 0, 0, 0.14);
}

.menu-open-button:hover {
  -webkit-transform: scale(1.2, 1.2) translate3d(0, 0, 0);
  transform: scale(1.2, 1.2) translate3d(0, 0, 0);
}

.menu-open:checked + .menu-open-button {
  -webkit-transition-timing-function: linear;
  transition-timing-function: linear;
  -webkit-transition-duration: 200ms;
  transition-duration: 200ms;
  -webkit-transform: scale(0.8, 0.8) translate3d(0, 0, 0);
  transform: scale(0.8, 0.8) translate3d(0, 0, 0);
}

.menu-open:checked ~ .menu-item {
  -webkit-transition-timing-function: cubic-bezier(0.935, 0, 0.34, 1.33);
  transition-timing-function: cubic-bezier(0.935, 0, 0.34, 1.33);
}

.menu-open:checked ~ .menu-item:nth-child(3) {
  transition-duration: 180ms;
  -webkit-transition-duration: 180ms;
  -webkit-transform: translate3d(0.08361px, -104.99997px, 0);
  transform: translate3d(0.08361px, -104.99997px, 0);
}

.menu-open:checked ~ .menu-item:nth-child(4) {
  transition-duration: 280ms;
  -webkit-transition-duration: 280ms;
  -webkit-transform: translate3d(90.9466px, -52.47586px, 0);
  transform: translate3d(90.9466px, -52.47586px, 0);
}

.menu-open:checked ~ .menu-item:nth-child(5) {
  transition-duration: 380ms;
  -webkit-transition-duration: 380ms;
  -webkit-transform: translate3d(90.9466px, 52.47586px, 0);
  transform: translate3d(90.9466px, 52.47586px, 0);
}

.menu-open:checked ~ .menu-item:nth-child(6) {
  transition-duration: 480ms;
  -webkit-transition-duration: 480ms;
  -webkit-transform: translate3d(0.08361px, 104.99997px, 0);
  transform: translate3d(0.08361px, 104.99997px, 0);
}

.menu-open:checked ~ .menu-item:nth-child(7) {
  transition-duration: 580ms;
  -webkit-transition-duration: 580ms;
  -webkit-transform: translate3d(-90.86291px, 52.62064px, 0);
  transform: translate3d(-90.86291px, 52.62064px, 0);
}

.menu-open:checked ~ .menu-item:nth-child(8) {
  transition-duration: 680ms;
  -webkit-transition-duration: 680ms;
  -webkit-transform: translate3d(-91.03006px, -52.33095px, 0);
  transform: translate3d(-91.03006px, -52.33095px, 0);
}

.menu-open:checked ~ .menu-item:nth-child(9) {
  transition-duration: 780ms;
  -webkit-transition-duration: 780ms;
  -webkit-transform: translate3d(-0.25084px, -104.9997px, 0);
  transform: translate3d(-0.25084px, -104.9997px, 0);
}

/* The core CSS / CSS3 styles for the round menu.*/
.menu-item {
  background: #EEEEEE;
  border-radius: 100%;
  width: v-bind(buttonSize);
  height: v-bind(buttonSize);
  /*margin-left: -40px;*/
  position: absolute;
  color: #FFFFFF;
  text-align: center;
  line-height: v-bind(buttonLineHeight);
  -webkit-transform: translate3d(0, 0, 0);
  transform: translate3d(0, 0, 0);
  -webkit-transition: -webkit-transform ease-out 200ms;
  transition: -webkit-transform ease-out 200ms;
  transition: transform ease-out 200ms;
  transition: transform ease-out 200ms, -webkit-transform ease-out 200ms;
}

.menu {
  display: inline;
  margin: auto;
  position: v-bin(menuPosition);
  top: 0;
  bottom: 0;
  left: 0;
  right: 0;
  width: v-bin(buttonSize);
  height: v-bin(buttonSize);
  /*text-align: center;*/
  box-sizing: border-box;
  z-index: 99;
  /*font-size: 26px;*/
}

.menu-item:hover {
  background: #EEEEEE;
  color: #3290B1;
}

.menu-item:nth-child(3) {
  -webkit-transition-duration: 180ms;
  transition-duration: 180ms;
}

.menu-item:nth-child(4) {
  -webkit-transition-duration: 180ms;
  transition-duration: 180ms;
}

.menu-item:nth-child(5) {
  -webkit-transition-duration: 180ms;
  transition-duration: 180ms;
}

.menu-item:nth-child(6) {
  -webkit-transition-duration: 180ms;
  transition-duration: 180ms;
}

.menu-item:nth-child(7) {
  -webkit-transition-duration: 180ms;
  transition-duration: 180ms;
}

.menu-item:nth-child(8) {
  -webkit-transition-duration: 180ms;
  transition-duration: 180ms;
}

.menu-item:nth-child(9) {
  -webkit-transition-duration: 180ms;
  transition-duration: 180ms;
}

.item-1 {
  background-color: #669AE1;
  box-shadow: 3px 3px 0 0 rgba(0, 0, 0, 0.14);
  text-shadow: 1px 1px 0 rgba(0, 0, 0, 0.12);
}

.item-1:hover {
  color: #669AE1;
  text-shadow: none;
}

.item-2 {
  background-color: #70CC72;
  box-shadow: 3px 3px 0 0 rgba(0, 0, 0, 0.14);
  text-shadow: 1px 1px 0 rgba(0, 0, 0, 0.12);
}

.item-2:hover {
  color: #70CC72;
  text-shadow: none;
}

.item-3 {
  background-color: #FE4365;
  box-shadow: 3px 3px 0 0 rgba(0, 0, 0, 0.14);
  text-shadow: 1px 1px 0 rgba(0, 0, 0, 0.12);
}

.item-3:hover {
  color: #FE4365;
  text-shadow: none;
}

.item-4 {
  background-color: #C49CDE;
  box-shadow: 3px 3px 0 0 rgba(0, 0, 0, 0.14);
  text-shadow: 1px 1px 0 rgba(0, 0, 0, 0.12);
}

.item-4:hover {
  color: #C49CDE;
  text-shadow: none;
}

.item-5 {
  background-color: #FC913A;
  box-shadow: 3px 3px 0 0 rgba(0, 0, 0, 0.14);
  text-shadow: 1px 1px 0 rgba(0, 0, 0, 0.12);
}

.item-5:hover {
  color: #FC913A;
  text-shadow: none;
}

.item-6 {
  background-color: #62C2E4;
  box-shadow: 3px 3px 0 0 rgba(0, 0, 0, 0.14);
  text-shadow: 1px 1px 0 rgba(0, 0, 0, 0.12);
}

.item-6:hover {
  color: #62C2E4;
  text-shadow: none;
}

</style>
